package swing.book;

import java.awt.EventQueue;

import javax.swing.AbstractButton;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

import java.awt.Font;

import javax.swing.UIManager;

import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JLabel;

public class BookApp {

	private JFrame frame;
	private JTable table;
	private BookDialog dialog;
	BookTableModel model;
	private BookFindDialog dialog2;
	private BookChangeDialog dialog3;
	JLabel totalLabel;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					BookApp window = new BookApp();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public BookApp() {
		
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		
		frame = new JFrame();
		frame.setBounds(100, 100, 817, 489);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);
		
		
		JButton btn1 = new JButton("");
		btn1.setBounds(183, 31, 97, 53);
		btn1.setFont(new Font("", Font.BOLD, 14));
		frame.getContentPane().add(btn1);
		
		model= new BookTableModel();
		
		Book b1 = new Book("20","Ҽ" , "ڹ", "", "߾", "2011-09", 20000, 1);
		Book b2 = new Book("24","Ҽ" , "ڹ2", "2", "߾", "2011-09", 17000, 3);
		Book b3 = new Book("25","Ҽ" , "ڹ3", "3", "߾", "2011-09", 34000, 0);
		Book b4 = new Book("27","Ҽ" , "ڹ4", "4", "߾", "2011-09", 28000, 2);
		model.addBookInfo(b1);
		model.addBookInfo(b2);
		model.addBookInfo(b3);
		model.addBookInfo(b4);
		
		dialog= new BookDialog(model);
		btn1.addActionListener( e->{
			dialog.setVisible(true);
		});
		
		dialog2= new BookFindDialog(model);
		JButton btn2 = new JButton("˻");
		btn2.setBounds(425, 31, 97, 53);
		btn2.setFont(new Font("", Font.BOLD, 14));
		frame.getContentPane().add(btn2);
		btn2.addActionListener(e->{
			dialog2.setVisible(true);
			
		});
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(25, 177, 738, 196);
		frame.getContentPane().add(scrollPane);
		
		table = new JTable(model);
		scrollPane.setViewportView(table);
		
		table.getModel().addTableModelListener(new TableModelListener() {
			
			public void tableChanged(TableModelEvent e) {
				totalLabel.setText(String.valueOf( model.totalPrice()));
			}
		});
		
		dialog3= new BookChangeDialog(model);
		table.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e){
				if(e.getClickCount()==2){
					dialog3.setVisible(true);
					
					int rowindex = table.getSelectedRow();
					
					Book b = model.getBookByRowIndex(rowindex);
							
					dialog3.noField.setText(b.getNo());
					dialog3.fieldField.setText(b.getField());
					dialog3.nameField.setText(b.getName());
					dialog3.authorField.setText(b.getAuthor());
					dialog3.publisherField.setText(b.getPublisher());
					dialog3.dateField.setText(b.getDate());
					dialog3.priceField.setText( String.valueOf(b.getPrice()) );
					dialog3.gradeComboBox.setSelectedItem(String.valueOf(b.getGrade()));		
				}
			}	
		});
	
		
		
		JPanel panel = new JPanel();
		panel.setBounds(12, 143, 769, 254);
		panel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "\uC870\uD68C", TitledBorder.LEADING, TitledBorder.TOP, null, new Color(0, 0, 0)));
		frame.getContentPane().add(panel);
		
		JLabel lblNewLabel = new JLabel("\uCD1D\uC810 : ");
		lblNewLabel.setFont(new Font("", Font.BOLD, 14));
		lblNewLabel.setBounds(542, 404, 64, 24);
		frame.getContentPane().add(lblNewLabel);
		
		totalLabel = new JLabel("");
		totalLabel.setFont(new Font("", Font.BOLD, 14));
		totalLabel.setBounds(605, 407, 106, 24);
		frame.getContentPane().add(totalLabel);
		
		totalLabel.setText( String.valueOf( model.totalPrice() ) );
		
		
	}
}
