package swing.book;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.text.DecimalFormat;

import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;

import swing.table.ContactDialog;

public class BookChangeDialog extends JDialog {

	private final JPanel contentPanel = new JPanel();
	JTextField noField;
	BookTableModel model;
	JTextField fieldField;
	JTextField nameField;
	JTextField authorField;
	JTextField publisherField;
	JTextField dateField;
	JTextField priceField;
	JTextField textField;
	JTextField gradeField;
	JComboBox gradeComboBox;

	// JComboBox comboBox;
	// Object gradeField;

	/**
	 * Launch the application.
	 */

	/**
	 * Create the dialog.
	 */
	public BookChangeDialog(BookTableModel model) {
		this.model = model;
		setBounds(100, 100, 571, 523);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JPanel panel = new JPanel();
			panel.setBorder(new TitledBorder(null,
					"\uB3C4\uC11C \uC815\uBCF4 \uC218\uC815",
					TitledBorder.LEADING, TitledBorder.TOP, null, null));
			panel.setBounds(12, 10, 534, 432);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				JLabel lblNewLabel = new JLabel("\uB3C4\uC11C \uBC88\uD638");
				lblNewLabel.setBounds(32, 25, 61, 15);
				panel.add(lblNewLabel);
			}
			{
				noField = new JTextField();
				noField.setBounds(118, 22, 347, 21);
				panel.add(noField);
				noField.setColumns(10);
			}
			{
				JLabel label = new JLabel("\uAC00       \uACA9");
				label.setBounds(32, 337, 61, 15);
				panel.add(label);
			}
			{
				JLabel label = new JLabel("\uD3C9       \uC810");
				label.setBounds(32, 389, 61, 15);
				panel.add(label);
			}
			{
				JLabel lblCnfvksdLF = new JLabel("\uCD9C  \uD310  \uC77C");
				lblCnfvksdLF.setBounds(32, 285, 61, 15);
				panel.add(lblCnfvksdLF);
			}
			{
				JLabel label = new JLabel("\uC800       \uC790");
				label.setBounds(32, 186, 61, 15);
				panel.add(label);
			}
			{
				JLabel label = new JLabel("\uCD9C  \uD310  \uC0AC");
				label.setBounds(32, 233, 61, 15);
				panel.add(label);
			}
			{
				JLabel label = new JLabel("\uB3C4  \uC11C  \uBA85");
				label.setBounds(32, 129, 61, 15);
				panel.add(label);
			}
			{
				JLabel label = new JLabel("\uBD84  \uC57C  \uBCC4");
				label.setBounds(32, 77, 61, 15);
				panel.add(label);
			}
			{
				fieldField = new JTextField();
				fieldField.setEditable(false);
				fieldField.setColumns(10);
				fieldField.setBounds(118, 74, 347, 21);
				panel.add(fieldField);
			}

			{
				authorField = new JTextField();
				authorField.setEditable(false);
				authorField.setColumns(10);
				authorField.setBounds(118, 180, 347, 21);
				panel.add(authorField);
			}
			{
				publisherField = new JTextField();
				publisherField.setEditable(false);
				publisherField.setColumns(10);
				publisherField.setBounds(118, 233, 347, 21);
				panel.add(publisherField);
			}
			{
				dateField = new JTextField();
				dateField.setEditable(false);
				dateField.setColumns(10);
				dateField.setBounds(118, 279, 347, 21);
				panel.add(dateField);
			}
			{
				priceField = new JTextField();
				priceField.setColumns(10);
				priceField.setBounds(118, 331, 347, 21);
				panel.add(priceField);
			}
			{
				nameField = new JTextField();
				nameField.setEditable(false);
				nameField.setColumns(10);
				nameField.setBounds(118, 123, 347, 21);
				panel.add(nameField);
			}

			
			gradeComboBox = new JComboBox();
			gradeComboBox.setModel(new DefaultComboBoxModel(new String[] {
					"\u2605", "\u2605\u2605", "\u2605\u2605\u2605",
					"\u2605\u2605\u2605\u2605",
					"\u2605\u2605\u2605\u2605\u2605" }));
			gradeComboBox.setBounds(118, 389, 347, 21);
			panel.add(gradeComboBox);

			{
				JPanel buttonPane = new JPanel();
				buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
				getContentPane().add(buttonPane, BorderLayout.SOUTH);
				{
					JButton okButton = new JButton("\uC218\uC815");
					okButton.setActionCommand("OK");
					buttonPane.add(okButton);
					getRootPane().setDefaultButton(okButton);
					okButton.addActionListener(e -> {
						String no = noField.getText();

						String name = nameField.getText();
						String author = authorField.getText();
						String publisher = publisherField.getText();
						String Date = dateField.getText();
						
						int price = Integer.parseInt(priceField.getText());
					
						String genre = fieldField.getText();
						int grade = gradeComboBox.getSelectedIndex();

						
						Book books = new Book(no, genre, name, author,
								publisher, Date, price, grade);

						model.updateBook(books);

						BookChangeDialog.this.setVisible(false);
					});
				}
				{
					JButton cancelButton = new JButton("\uCDE8\uC18C");
					cancelButton.setActionCommand("Cancel");
					buttonPane.add(cancelButton);
					cancelButton.addActionListener(e -> {
						BookChangeDialog.this.setVisible(false);
					});
				}
			}
		}
	}
}
