package swing.book;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.text.DecimalFormat;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;

public class BookDialog extends JDialog {

	private final JPanel contentPanel = new JPanel();
	private JTextField noField;
	private JTextField nameField;
	private JTextField authorField;
	private JTextField publisherField;
	private JTextField dateField;
	private JTextField priceField;
	private static BookTableModel model;


	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			BookDialog dialog = new	BookDialog(model);

			dialog.setDefaultCloseOperation

			(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public BookDialog(BookTableModel model) {
		this.model=model;
		setBounds(100, 100, 649, 563);
		getContentPane().setLayout(new

		BorderLayout());
		contentPanel.setBorder(new  EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel,BorderLayout.CENTER);
		contentPanel.setLayout(null);

		JLabel lblNewLabel = new JLabel	("\uB3C4\uC11C \uBC88\uD638");
		lblNewLabel.setBounds(36, 85, 57, 15);
		contentPanel.add(lblNewLabel);

		JLabel lblNewLabel_1 = new JLabel("\uBD84       \uC57C");
		lblNewLabel_1.setBounds(36, 129, 57,15);
		contentPanel.add(lblNewLabel_1);

		JLabel lblNewLabel_2 = new JLabel("\uB3C4  \uC11C  \uBA85");
		lblNewLabel_2.setBounds(36, 173, 57,15);
		contentPanel.add(lblNewLabel_2);

		JLabel lblNewLabel_3 = new JLabel("\uC800       \uC790");
		lblNewLabel_3.setBounds(36, 217, 57,15);
		contentPanel.add(lblNewLabel_3);

		JLabel lblNewLabel_4 = new JLabel	("\uCD9C  \uD310  \uC0AC");
		lblNewLabel_4.setBounds(36, 261, 57,15);
		contentPanel.add(lblNewLabel_4);

		JLabel lblNewLabel_5 = new JLabel("\uCD9C  \uD310  \uC77C");
		lblNewLabel_5.setBounds(36, 305, 57,15);
		contentPanel.add(lblNewLabel_5);

		JLabel lblNewLabel_6 = new JLabel	("\uAC00       \uACA9");
		lblNewLabel_6.setBounds(36, 349, 57,	15);
		contentPanel.add(lblNewLabel_6);

		JLabel lblNewLabel_7 = new JLabel	("\uD3C9       \uC810");
		lblNewLabel_7.setBounds(36, 393, 57,	15);
		contentPanel.add(lblNewLabel_7);

		noField = new JTextField();
		noField.setBounds(139, 82, 421, 21);
		contentPanel.add(noField);
		noField.setColumns(10);

		
		nameField = new JTextField();
		nameField.setBounds(139, 170, 421, 21);
		contentPanel.add(nameField);
		nameField.setColumns(10);

		authorField = new JTextField();
		authorField.setBounds(139, 214, 421,21);
		contentPanel.add(authorField);
		authorField.setColumns(10);

		publisherField = new JTextField();
		publisherField.setBounds(139, 258, 421,	21);
		contentPanel.add(publisherField);
		publisherField.setColumns(10);

		dateField = new JTextField();
		dateField.setBounds(139, 302, 421, 21);
		contentPanel.add(dateField);
		dateField.setColumns(10);

		priceField = new JTextField();
		priceField.setBounds(139, 346, 421, 21);
		contentPanel.add(priceField);
		priceField.setColumns(10);
		
		noField.addActionListener(e->{
			nameField.requestFocus();
		});
		nameField.addActionListener(e->{
			authorField.requestFocus();
		});
		authorField.addActionListener(e->{
			publisherField.requestFocus();
		});
		publisherField.addActionListener(e->{
			dateField.requestFocus();
		});
		dateField.addActionListener(e->{
			priceField.requestFocus();
		});
		
		JComboBox comboBox = new JComboBox();
		comboBox.setModel(new DefaultComboBoxModel(new String[] {"Ҽ", "Ҽ", ""}));
		comboBox.setBounds(139, 126, 421, 21);
		contentPanel.add(comboBox);
		
		JComboBox comboBox_1 = new JComboBox();
		comboBox_1.setModel(new DefaultComboBoxModel(new String[] {"", "ڡ", "ڡڡ", "ڡڡڡ", "ڡڡڡڡ"}));
		comboBox_1.setBounds(139, 390, 421, 21);
		contentPanel.add(comboBox_1);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "\uB3C4\uC11C \uC815\uBCF4 \uC785\uB825", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(25, 50, 569, 399);
		contentPanel.add(panel);
		{
			JPanel buttonPane = new	JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton =new JButton("");
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);

				okButton.addActionListener(e -> {
					String no =	noField.getText();
					
					String name = nameField.getText();
					String author = authorField.getText();
					String publisher = publisherField.getText();
					String Date = dateField.getText();
					//int date = Integer.parseInt(Date);
					int price = Integer.parseInt(priceField.getText());
					
					String genre = (String)comboBox.getSelectedItem();
//					String grade = (String)comboBox_1.getSelectedItem();
					int grade = comboBox_1.getSelectedIndex();
					 Book books = new Book(no, genre, name, author, publisher, Date, price, grade);

					 model.addBookInfo(books);
					
					 noField.setText("");
					 nameField.setText("");
					 authorField.setText("");
					 publisherField.setText("");
					 dateField.setText("");
					 priceField.setText("");
					
					 BookDialog.this.setVisible(false);
				});
			}
			{
				JButton cancelButton= new JButton("");

				cancelButton.setActionCommand("Cancel");
				buttonPane.add	(cancelButton);

				cancelButton.addActionListener(e -> {

					BookDialog.this.setVisible(false);
				});
			}
		}
	}
}
