package swing.book;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.UIManager;

import java.awt.Color;
import java.text.DecimalFormat;

import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JRadioButton;

import swing.util.GroupButtonUtils;

import java.awt.Font;

public class BookFindDialog extends JDialog {

	private final JPanel contentPanel = new JPanel();
	private JTable table;
	private BookTableModel model;
	private BookTableModel resultModel;
	private JTextField textField;




	/**
	 * Create the dialog.
	 */
	public BookFindDialog(BookTableModel model) {
		this.model=model;
		resultModel = new BookTableModel();
		setBounds(100, 100, 713, 495);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel);
		contentPanel.setLayout(null);
		{
			JPanel panel = new JPanel();
			panel.setBounds(12, 10, 660, 126);
			panel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "\uB3C4\uC11C \uAC80\uC0C9", TitledBorder.LEADING, TitledBorder.TOP, null, new Color(0, 0, 0)));
			contentPanel.add(panel);
			panel.setLayout(null);
			
			JRadioButton btn1 = new JRadioButton("о");
			btn1.setBounds(82, 25, 58, 23);
			panel.add(btn1);
			
			JRadioButton btn2 = new JRadioButton("");
			btn2.setBounds(222, 25, 67, 23);
			panel.add(btn2);
			
			JRadioButton btn3 = new JRadioButton("ǻ");
			btn3.setBounds(371, 25, 67, 23);
			panel.add(btn3);
			
			JRadioButton btn4 = new JRadioButton("\uAC00\uACA9");
			btn4.setBounds(520, 25, 58, 23);
			panel.add(btn4);
			
			ButtonGroup group = new ButtonGroup();
			group.add(btn1);
			group.add(btn2);
			group.add(btn3);
			group.add(btn4);
			
			JLabel lblNewLabel = new JLabel("\uAC80\uC0C9\uC5B4");
			lblNewLabel.setFont(new Font("", Font.BOLD, 14));
			lblNewLabel.setBounds(12, 79, 57, 15);
			panel.add(lblNewLabel);
			
			textField = new JTextField();
			textField.setBounds(77, 77, 386, 21);
			panel.add(textField);
			textField.setColumns(10);
			
			JButton btn = new JButton("˻");
			btn.setBounds(507, 76, 97, 23);
			panel.add(btn);
			
			btn.addActionListener(e->{
			String type  = GroupButtonUtils.selectedText(group);
			String keyword = textField.getText();
			
			resultModel.findBook(this.model.getBooks(), type, keyword);
			});
		}
		{
			JScrollPane scrollPane = new JScrollPane();
			scrollPane.setBounds(12, 184, 662, 216);
			contentPanel.add(scrollPane);
			
			
			table = new JTable(resultModel);
			scrollPane.setViewportView(table);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			
			{
				JButton cancelButton = new JButton("");
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
				cancelButton.addActionListener(e->{
					BookFindDialog.this.setVisible(false);
				});
			}
		}
	}
}
