package swing.book;

import java.text.DecimalFormat;
import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;

public class BookTableModel extends AbstractTableModel {

	String[] name = { "ȣ", "о", "", "", "ǻ", "", "", "" };
	ArrayList<Book> books = new ArrayList<Book>();

	public int getRowCount() {
		return books.size();
	}

	public int getColumnCount() {
		return name.length;
	}

	public String getColumnName(int column) {
		return name[column];
	}

	// ̺ ͸ ѷٶ  ص  arraylist  ʴ´.
	public Object getValueAt(int rowIndex, int columnIndex) {
		Book b = books.get(rowIndex);
		if (columnIndex == 0) {
			return b.getNo();
		}
		if (columnIndex == 1) {
			return b.getField();
		}
		if (columnIndex == 2) {
			return b.getName();
		}
		if (columnIndex == 3) {
			return b.getAuthor();
		}
		if (columnIndex == 4) {
			return b.getPublisher();
		}
		if (columnIndex == 5) {
			return b.getDate();
		}
		if (columnIndex == 6) {
			return showPrice(b.getPrice());
		}
		if (columnIndex == 7) {
			return showGrade(b.getGrade());
		} else {
			return null;
		}

	}

	public void addBookInfo(Book b) {
		books.add(b);
		totalPrice();
		this.fireTableDataChanged();
	}

	public void findBook(ArrayList<Book> books, String type, String keyword) {
		this.books = books;
		ArrayList<Book> result = new ArrayList<Book>();
		if ("о".equals(type)) {
			for (Book b : books) {
				if (b.getField().contains(keyword)) {
					result.add(b);
				}
			}
		} else if ("".equals(type)) {
			for (Book b : books) {
				if (b.getName().contains(keyword)) {
					result.add(b);
				}
			}
		} else if ("ǻ".equals(type)) {
			for (Book b : books) {
				if (b.getPublisher().contains(keyword)) {
					result.add(b);
				}
			}
		} else if ("".equals(type)) {
			for (Book b : books) {
				if ( b.getPrice() == Integer.parseInt(keyword) ) {
					result.add(b);
				}
			}
		}

		else {
			return;
		}
		// this.books=result;
		this.fireTableDataChanged();

	}

	public ArrayList<Book> getBooks() {
		return books;
	}

	public Book getBookByRowIndex(int index) {
		Book b = books.get(index);
		return b;
	}

	public void updateBook(Book b) {
		for (Book book : books) {
			if (b.getName().equals(book.getName())) {
				book.setNo(b.getNo());
				book.setPrice(b.getPrice());
				book.setGrade(b.getGrade());
				break;
			}
		}
		this.fireTableDataChanged();
	}

	public String showGrade(int grade) {
		String str = "";
		switch(grade) {
		case 0:
			str = "ڡ١١١";
			break;
		case 1:
			str = "ڡڡ١١";
			break;
		case 2:
			str = "ڡڡڡ١";
			break;
		case 3:
			str = "ڡڡڡڡ";
			break;
		case 4:
			str = "ڡڡڡڡ";
			break;
			
		}
		return str;
	}
	public String showPrice(int price){
		
		DecimalFormat df = new DecimalFormat("##,###");
		
		String str2 = df.format(price) + "";
		
		
		return str2;
	}
	
	public int totalPrice() {
		int total = 0;
		for (Book b : books){
			total += b.getPrice();
		}
		return total;
	}
}
