package swing.table;

import java.awt.Component;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JLabel;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

import java.awt.Color;

import javax.swing.border.TitledBorder;
import javax.swing.border.BevelBorder;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.border.SoftBevelBorder;
import javax.swing.border.MatteBorder;
import javax.swing.UIManager;
import javax.swing.SwingConstants;

import java.awt.FlowLayout;

public class ContactApp {

	private JFrame frame;
	private JTextField nameField;
	private JTextField phoneField;
	private JTextField emailField;
	private JTable table;
	private ContactTableModel model;
	private JTextField delField;
	private ContactDialog dialog;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					ContactApp window = new ContactApp();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public ContactApp() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 509, 607);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);
		
		JLabel lblNewLabel = new JLabel("\uC5F0\uB77D\uCC98 \uAD00\uB9AC");
		lblNewLabel.setFont(new Font("", Font.BOLD, 16));
		lblNewLabel.setBounds(12, 0, 438, 45);
		frame.getContentPane().add(lblNewLabel);
	
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "\uB4F1\uB85D", TitledBorder.LEADING, TitledBorder.TOP, null, new Color(0, 0, 0)));
		//(new BevelBorder(BevelBorder.LOWERED),""));
		panel.setBounds(12, 47, 469, 113);
		frame.getContentPane().add(panel);
		panel.setLayout(null);
		
		JLabel lblNewLabel_1 = new JLabel("\uC774\uB984");
		lblNewLabel_1.setHorizontalAlignment(SwingConstants.LEFT);
		lblNewLabel_1.setBounds(12, 24, 57, 15);
		panel.add(lblNewLabel_1);
		lblNewLabel_1.setFont(new Font("", Font.PLAIN, 14));
		
		JLabel lblNewLabel_2 = new JLabel("\uC5F0\uB77D\uCC98");
		lblNewLabel_2.setHorizontalAlignment(SwingConstants.LEFT);
		lblNewLabel_2.setBounds(12, 49, 57, 15);
		panel.add(lblNewLabel_2);
		lblNewLabel_2.setFont(new Font("", Font.PLAIN, 14));
		
		JLabel lblNewLabel_3 = new JLabel("E-mail");
		lblNewLabel_3.setHorizontalAlignment(SwingConstants.LEFT);
		lblNewLabel_3.setBounds(12, 74, 57, 15);
		panel.add(lblNewLabel_3);
		lblNewLabel_3.setFont(new Font("", Font.PLAIN, 14));
		
		nameField = new JTextField();
		nameField.setBounds(93, 21, 213, 24);
		panel.add(nameField);
		nameField.setColumns(10);
		
		phoneField = new JTextField();
		phoneField.setBounds(92, 47, 213, 21);
		panel.add(phoneField);
		phoneField.setColumns(10);
		
		emailField = new JTextField();
		emailField.setBounds(92, 71, 213, 24);
		panel.add(emailField);
		emailField.setColumns(10);
		
		phoneField.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				emailField.requestFocus();
			}
		});
		
		nameField.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				phoneField.requestFocus();
			}
		});
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "\uC0AD\uC81C", TitledBorder.LEADING, TitledBorder.TOP, null, new Color(255, 0, 0)));
		panel_1.setBounds(12, 188, 469, 70);
		frame.getContentPane().add(panel_1);
		panel_1.setLayout(null);
		
		JLabel lblNewLabel_4 = new JLabel("\uC774\uB984");
		lblNewLabel_4.setForeground(new Color(0, 0, 0));
		lblNewLabel_4.setFont(new Font("", Font.BOLD, 14));
		lblNewLabel_4.setEnabled(false);
		lblNewLabel_4.setHorizontalAlignment(SwingConstants.LEFT);
		lblNewLabel_4.setBounds(16, 30, 42, 18);
		panel_1.add(lblNewLabel_4);
		
		delField = new JTextField();
		delField.setBounds(82, 27, 171, 21);
		panel_1.add(delField);
		delField.setColumns(15);
		
		JLabel lblNewLabel_5 = new JLabel("\uC5F0\uB77D\uCC98 \uBAA9\uB85D");
		lblNewLabel_5.setFont(new Font("", Font.BOLD, 14));
		lblNewLabel_5.setBounds(12, 268, 120, 22);
		frame.getContentPane().add(lblNewLabel_5);
		
		JButton btn = new JButton("\uB4F1\uB85D");
		btn.setFont(new Font("", Font.BOLD, 14));
		btn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String name = nameField.getText();
				String phone = phoneField.getText();
				String email = emailField.getText();
				
				if(name.isEmpty()){
					nameField.requestFocus();
					return;
				}if(phone.isEmpty()){
					phoneField.requestFocus();
					return;
				}if(email.isEmpty()){
					emailField.requestFocus();
					return;
				}
				Contact c = new Contact(name, phone, email);
				model.addContact(c);// jtable tablemodelü ο ó ߰.
				
				nameField.setText("");
				phoneField.setText("");
				emailField.setText("");
			}
		});
		
		btn.setBounds(353, 65, 97, 77);
		frame.getContentPane().add(btn);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(12, 300, 469, 247);
		frame.getContentPane().add(scrollPane);
		
		model= new ContactTableModel();
		
		table = new JTable(model);
		scrollPane.setViewportView(table);
		
		JButton but2 = new JButton("\uC0AD\uC81C");
		but2.setFont(new Font("", Font.BOLD, 14));
		but2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String name = delField.getText();
				
				if(name.isEmpty()){
					delField.requestFocus();
					return;
				}
				model.removeContactByName(name);
				delField.setText("");
			}
		});
		
		but2.setBounds(353, 207, 97, 31);
		frame.getContentPane().add(but2);
		
		dialog = new ContactDialog(model);
		//jtable  Ŭ
		table.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e){
				if (e.getClickCount() ==2){
					dialog.setVisible(true);
				// డ 
					int rowIndex = table.getSelectedRow();
				//	System.out.println(rowIndex);
					//tablemodel å  ó
					Contact c = model.getContactByRowIndex(rowIndex);
					//dialog ǥ
					dialog.nameField.setText(c.getName());
					dialog.phoneField.setText(c.getPhone());
					dialog.emailField.setText(c.getEmail());
				}
			}
		});
	
		
	}
}
