drop table review;
drop table book;
drop table price_info;
drop table member;
drop table performance;
drop table notice;
drop table news;
drop SEQUENCE perform_seq;
drop SEQUENCE review_seq;
drop SEQUENCE book_seq;
drop SEQUENCE price_seq;
drop sequence notice_seq;
drop sequence news_seq;



create table member (
  member_id varchar2(300) CONSTRAINT mem_id_pk PRIMARY KEY,
  email varchar2(300),
  password varchar2(16),
  name varchar2(50),
  birth date,
  gender char(1) CONSTRAINT mem_gender_ck CHECK (gender in ('F','M')),
  addr varchar2(300),
  zipcode char(6),
  phone varchar2(30),
  regdate date
);

create table performance (
  no number CONSTRAINT perform_no_pk PRIMARY key,
  title varchar2(500),
  genre varchar2(50),
  start_date date,
  end_date date,
  time varchar2(200),
  runningtime number,
  place varchar2(100),
  grade varchar2(100),
  contact varchar2(500),
  seat number,
  discount_yn char(1),
  contents clob,
  regdate date,
  local varchar2(20),
  image varchar2(300)
);

create table review(
  no number constraint REVIEW_NO_PK PRIMARY KEY,
  area varchar2(50),
  member_id varchar2(200) constraint REVIEW_mid_fk references member(member_id),
  performance_no number constraint REVIEW_pno_fk references performance(no),
  title varchar2(1000),
  regdate date,
  hit number,
  viewdate date,
  contents clob,
  comm varchar2(2000)
);

create table book (
  no number CONSTRAINT book_no_pk PRIMARY key,
  member_id  varchar2(200) constraint book_mid_fk references member(member_id),
  performance_no number CONSTRAINT book_pno_fk REFERENCES performance(no),
  bookdate date,
  qty number,
  show_no number,
  adult number,
  student number,
  kid number,
  regdate date
);

create table price_info (
  no number CONSTRAINT price_no_pk PRIMARY key,
  adult number,
  student number,
  kid number,
  performance_no number CONSTRAINT price_perform_fk REFERENCES performance(no)
);

create table notice (
  no number constraint notice_no_pk primary key,
  title varchar2(1000),
  local varchar2(20),
  contents clob,
  hit number,
  regdate date
);

create table news (
  no number constraint news_no_pk primary key,
  media varchar2(200),
  title varchar2(1000),
  regdate date,
  hit number,
  contents clob
);


CREATE SEQUENCE perform_seq
        START WITH 1
        INCREMENT BY 1
;
CREATE SEQUENCE review_seq
        START WITH 1
        INCREMENT BY 1
;
CREATE SEQUENCE book_seq
        START WITH 1
        INCREMENT BY 1
;
CREATE SEQUENCE price_seq
        START WITH 1
        INCREMENT BY 1
;
CREATE SEQUENCE notice_seq
        START WITH 1
        INCREMENT BY 1
;
CREATE SEQUENCE news_seq
        START WITH 1
        INCREMENT BY 1
;

--insert into performance 
--(no, title, sub_title, genre, start_date, end_date, place, local, image, regdate)
--SELECT perform_seq.nextval, TITLE, title sub_title,GENRE,startdate start_date, ENDDATE end_date, PLACE,LOCAL,IMAGE,sysdate FROM performance_temp;
        
--update performance set time  = '오전 10:00, 오후 02:00';
--commit;


--insert into price_info
--(NO, PERFORMANCE_NO, kid, student, adult)
--select price_seq.nextval, no performance_no, 20000 kid, 30000 student, 40000 adult from performance;



INSERT INTO MEMBER
(MEMBER_ID, EMAIL, password, name, birth, gender,  addr, zipcode, phone, regdate)
values
('te2', 'a',11,'네임','2010-01-01','M','큰집',110138,01014789335,sysdate);

INSERT INTO MEMBER
(MEMBER_ID, EMAIL, password, name, birth, gender,  addr, zipcode, phone, regdate)
values
('te1', 'a',11,'이름','2010-01-01','M','큰집',110138,01014789335,sysdate);

INSERT INTO MEMBER
(MEMBER_ID, EMAIL, password, name, birth, gender,  addr, zipcode, phone, regdate)
values
('te3', 'a',11,'일음','2010-01-01','M','큰집',110138,01014789335,sysdate);

INSERT INTO MEMBER
(MEMBER_ID, EMAIL, password, name, birth, gender,  addr, zipcode, phone, regdate)
values
('te4', 'a',11,'이름의','2010-01-01','M','큰집',110138,01014789335,sysdate);

INSERT INTO MEMBER
(MEMBER_ID, EMAIL, password, name, birth, gender,  addr, zipcode, phone, regdate)
values
('te5', 'a',11,'테슽명','2010-01-01','M','큰집',110138,01014789335,sysdate);

INSERT INTO MEMBER
(MEMBER_ID, EMAIL, password, name, birth, gender,  addr, zipcode, phone, regdate)
values
('test', 'aa',11,'테스트명','2010-01-01','M','큰집',110138,01014789335,sysdate);