package filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public class EncodingFilter implements Filter {
	private String defaultEncoding = null;
	
	// filter의 초기화 메소드
	@Override
	public void init(FilterConfig filterConfig) throws ServletException {
		// <init-param /> 설정값 읽어오기
		defaultEncoding = filterConfig.getInitParameter("encoding");
	}
	// filter의 소멸 메소드
	@Override
	public void destroy() {
		
	}
	// filter에서 실행할 작업을 구현하는 메소드
	@Override
	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {
		request.setCharacterEncoding(defaultEncoding);
		chain.doFilter(request, response);
		
	}
}
