package review;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import com.ibatis.sqlmap.client.SqlMapClient;

import comm.IbatisUtil;

public class BoardReviewDAO {
	
	public void addNewReview(BoardReviewVO review) throws SQLException{
		SqlMapClient sqlmap = IbatisUtil.getSqlmap();
		sqlmap.insert("addNewReview", review);
	}

	public int getReviewCount() throws SQLException{
		SqlMapClient sqlmap = IbatisUtil.getSqlmap();
		int count = (Integer)sqlmap.queryForObject("getReviewCount");
		return count;
	}
	
	public List<BoardListReviewVO> getBoardListReview(int start, int end) throws SQLException{
		SqlMapClient sqlmap = IbatisUtil.getSqlmap();
		HashMap map = new HashMap();
		map.put("start", start);
		map.put("end", end);
		List<BoardListReviewVO> list = sqlmap.queryForList("getBoardListReview", map);
		return list;
	}
	
	public Iterator<HashMap> getReviewSearch(String search) throws SQLException{
		SqlMapClient sqlmap = IbatisUtil.getSqlmap();
		List someList = (List)sqlmap.queryForList("getReviewSearch", search);
		Iterator<HashMap> iter = someList.iterator();
		return iter;
	}
	
	public BoardListReviewVO getReviewDetail(int value) throws SQLException{
		SqlMapClient sqlmap = IbatisUtil.getSqlmap();
		BoardListReviewVO review = (BoardListReviewVO)sqlmap.queryForObject("getReviewDetail", value);
		return review;
	}

	public String getPerformanceTitle(int value) throws SQLException{
		SqlMapClient sqlmap = IbatisUtil.getSqlmap();
		String title = (String)sqlmap.queryForObject("getPerformanceTitle", value);
		return title;
	}

	public void updateReviewCount(int value) throws SQLException{
		SqlMapClient sqlmap = IbatisUtil.getSqlmap();
		sqlmap.update("updateReviewCount", value);
	}
	
}
